git-am.shon commit Merge branch 'maint-1.6.2' into maint (8fb5d44)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [<mbox>|<Maildir>...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18c,scissors      strip everything before a scissors line
  19whitespace=     pass it through git-apply
  20ignore-space-change pass it through git-apply
  21ignore-whitespace pass it through git-apply
  22directory=      pass it through git-apply
  23C=              pass it through git-apply
  24p=              pass it through git-apply
  25patch-format=   format the patch(es) are in
  26reject          pass it through git-apply
  27resolvemsg=     override error message when patch failure occurs
  28r,resolved      to be used after a patch failure
  29skip            skip the current patch
  30abort           restore the original branch and abort the patching operation.
  31committer-date-is-author-date    lie about committer date
  32ignore-date     use current timestamp for author date
  33rebasing*       (internal use for git-rebase)"
  34
  35. git-sh-setup
  36prefix=$(git rev-parse --show-prefix)
  37set_reflog_action am
  38require_work_tree
  39cd_to_toplevel
  40
  41git var GIT_COMMITTER_IDENT >/dev/null ||
  42        die "You need to set your committer info first"
  43
  44if git rev-parse --verify -q HEAD >/dev/null
  45then
  46        HAS_HEAD=yes
  47else
  48        HAS_HEAD=
  49fi
  50
  51sq () {
  52        git rev-parse --sq-quote "$@"
  53}
  54
  55stop_here () {
  56    echo "$1" >"$dotest/next"
  57    exit 1
  58}
  59
  60stop_here_user_resolve () {
  61    if [ -n "$resolvemsg" ]; then
  62            printf '%s\n' "$resolvemsg"
  63            stop_here $1
  64    fi
  65    cmdline="git am"
  66    if test '' != "$interactive"
  67    then
  68        cmdline="$cmdline -i"
  69    fi
  70    if test '' != "$threeway"
  71    then
  72        cmdline="$cmdline -3"
  73    fi
  74    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  75    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  76    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
  77
  78    stop_here $1
  79}
  80
  81go_next () {
  82        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  83                "$dotest/patch" "$dotest/info"
  84        echo "$next" >"$dotest/next"
  85        this=$next
  86}
  87
  88cannot_fallback () {
  89        echo "$1"
  90        echo "Cannot fall back to three-way merge."
  91        exit 1
  92}
  93
  94fall_back_3way () {
  95    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  96
  97    rm -fr "$dotest"/patch-merge-*
  98    mkdir "$dotest/patch-merge-tmp-dir"
  99
 100    # First see if the patch records the index info that we can use.
 101    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 102        "$dotest/patch" &&
 103    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 104    git write-tree >"$dotest/patch-merge-base+" ||
 105    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
 106
 107    say Using index info to reconstruct a base tree...
 108    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 109        git apply --cached <"$dotest/patch"
 110    then
 111        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 112        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 113    else
 114        cannot_fallback "Did you hand edit your patch?
 115It does not apply to blobs recorded in its index."
 116    fi
 117
 118    test -f "$dotest/patch-merge-index" &&
 119    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 120    orig_tree=$(cat "$dotest/patch-merge-base") &&
 121    rm -fr "$dotest"/patch-merge-* || exit 1
 122
 123    say Falling back to patching base and 3-way merge...
 124
 125    # This is not so wrong.  Depending on which base we picked,
 126    # orig_tree may be wildly different from ours, but his_tree
 127    # has the same set of wildly different changes in parts the
 128    # patch did not touch, so recursive ends up canceling them,
 129    # saying that we reverted all those changes.
 130
 131    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 132    export GITHEAD_$his_tree
 133    if test -n "$GIT_QUIET"
 134    then
 135            export GIT_MERGE_VERBOSITY=0
 136    fi
 137    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 138            git rerere
 139            echo Failed to merge in the changes.
 140            exit 1
 141    }
 142    unset GITHEAD_$his_tree
 143}
 144
 145clean_abort () {
 146        test $# = 0 || echo >&2 "$@"
 147        rm -fr "$dotest"
 148        exit 1
 149}
 150
 151patch_format=
 152
 153check_patch_format () {
 154        # early return if patch_format was set from the command line
 155        if test -n "$patch_format"
 156        then
 157                return 0
 158        fi
 159
 160        # we default to mbox format if input is from stdin and for
 161        # directories
 162        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 163        then
 164                patch_format=mbox
 165                return 0
 166        fi
 167
 168        # otherwise, check the first few lines of the first patch to try
 169        # to detect its format
 170        {
 171                read l1
 172                read l2
 173                read l3
 174                case "$l1" in
 175                "From "* | "From: "*)
 176                        patch_format=mbox
 177                        ;;
 178                '# This series applies on GIT commit'*)
 179                        patch_format=stgit-series
 180                        ;;
 181                "# HG changeset patch")
 182                        patch_format=hg
 183                        ;;
 184                *)
 185                        # if the second line is empty and the third is
 186                        # a From, Author or Date entry, this is very
 187                        # likely an StGIT patch
 188                        case "$l2,$l3" in
 189                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 190                                patch_format=stgit
 191                                ;;
 192                        *)
 193                                ;;
 194                        esac
 195                        ;;
 196                esac
 197                if test -z "$patch_format" &&
 198                        test -n "$l1" &&
 199                        test -n "$l2" &&
 200                        test -n "$l3"
 201                then
 202                        # This begins with three non-empty lines.  Is this a
 203                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 204                        # discarding the indented remainder of folded lines,
 205                        # and see if it looks like that they all begin with the
 206                        # header field names...
 207                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p "$1" |
 208                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 209                        patch_format=mbox
 210                fi
 211        } < "$1" || clean_abort
 212}
 213
 214split_patches () {
 215        case "$patch_format" in
 216        mbox)
 217                case "$rebasing" in
 218                '')
 219                        keep_cr= ;;
 220                ?*)
 221                        keep_cr=--keep-cr ;;
 222                esac
 223                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 224                clean_abort
 225                ;;
 226        stgit-series)
 227                if test $# -ne 1
 228                then
 229                        clean_abort "Only one StGIT patch series can be applied at once"
 230                fi
 231                series_dir=`dirname "$1"`
 232                series_file="$1"
 233                shift
 234                {
 235                        set x
 236                        while read filename
 237                        do
 238                                set "$@" "$series_dir/$filename"
 239                        done
 240                        # remove the safety x
 241                        shift
 242                        # remove the arg coming from the first-line comment
 243                        shift
 244                } < "$series_file" || clean_abort
 245                # set the patch format appropriately
 246                patch_format=stgit
 247                # now handle the actual StGIT patches
 248                split_patches "$@"
 249                ;;
 250        stgit)
 251                this=0
 252                for stgit in "$@"
 253                do
 254                        this=`expr "$this" + 1`
 255                        msgnum=`printf "%0${prec}d" $this`
 256                        # Perl version of StGIT parse_patch. The first nonemptyline
 257                        # not starting with Author, From or Date is the
 258                        # subject, and the body starts with the next nonempty
 259                        # line not starting with Author, From or Date
 260                        perl -ne 'BEGIN { $subject = 0 }
 261                                if ($subject > 1) { print ; }
 262                                elsif (/^\s+$/) { next ; }
 263                                elsif (/^Author:/) { print s/Author/From/ ; }
 264                                elsif (/^(From|Date)/) { print ; }
 265                                elsif ($subject) {
 266                                        $subject = 2 ;
 267                                        print "\n" ;
 268                                        print ;
 269                                } else {
 270                                        print "Subject: ", $_ ;
 271                                        $subject = 1;
 272                                }
 273                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 274                done
 275                echo "$this" > "$dotest/last"
 276                this=
 277                msgnum=
 278                ;;
 279        *)
 280                if test -n "$parse_patch" ; then
 281                        clean_abort "Patch format $patch_format is not supported."
 282                else
 283                        clean_abort "Patch format detection failed."
 284                fi
 285                ;;
 286        esac
 287}
 288
 289prec=4
 290dotest="$GIT_DIR/rebase-apply"
 291sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
 292resolvemsg= resume= scissors= no_inbody_headers=
 293git_apply_opt=
 294committer_date_is_author_date=
 295ignore_date=
 296
 297while test $# != 0
 298do
 299        case "$1" in
 300        -i|--interactive)
 301                interactive=t ;;
 302        -b|--binary)
 303                : ;;
 304        -3|--3way)
 305                threeway=t ;;
 306        -s|--signoff)
 307                sign=t ;;
 308        -u|--utf8)
 309                utf8=t ;; # this is now default
 310        --no-utf8)
 311                utf8= ;;
 312        -k|--keep)
 313                keep=t ;;
 314        -c|--scissors)
 315                scissors=t ;;
 316        --no-scissors)
 317                scissors=f ;;
 318        -r|--resolved)
 319                resolved=t ;;
 320        --skip)
 321                skip=t ;;
 322        --abort)
 323                abort=t ;;
 324        --rebasing)
 325                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 326        -d|--dotest)
 327                die "-d option is no longer supported.  Do not use."
 328                ;;
 329        --resolvemsg)
 330                shift; resolvemsg=$1 ;;
 331        --whitespace|--directory)
 332                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 333        -C|-p)
 334                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 335        --patch-format)
 336                shift ; patch_format="$1" ;;
 337        --reject|--ignore-whitespace|--ignore-space-change)
 338                git_apply_opt="$git_apply_opt $1" ;;
 339        --committer-date-is-author-date)
 340                committer_date_is_author_date=t ;;
 341        --ignore-date)
 342                ignore_date=t ;;
 343        -q|--quiet)
 344                GIT_QUIET=t ;;
 345        --)
 346                shift; break ;;
 347        *)
 348                usage ;;
 349        esac
 350        shift
 351done
 352
 353# If the dotest directory exists, but we have finished applying all the
 354# patches in them, clear it out.
 355if test -d "$dotest" &&
 356   last=$(cat "$dotest/last") &&
 357   next=$(cat "$dotest/next") &&
 358   test $# != 0 &&
 359   test "$next" -gt "$last"
 360then
 361   rm -fr "$dotest"
 362fi
 363
 364if test -d "$dotest"
 365then
 366        case "$#,$skip$resolved$abort" in
 367        0,*t*)
 368                # Explicit resume command and we do not have file, so
 369                # we are happy.
 370                : ;;
 371        0,)
 372                # No file input but without resume parameters; catch
 373                # user error to feed us a patch from standard input
 374                # when there is already $dotest.  This is somewhat
 375                # unreliable -- stdin could be /dev/null for example
 376                # and the caller did not intend to feed us a patch but
 377                # wanted to continue unattended.
 378                test -t 0
 379                ;;
 380        *)
 381                false
 382                ;;
 383        esac ||
 384        die "previous rebase directory $dotest still exists but mbox given."
 385        resume=yes
 386
 387        case "$skip,$abort" in
 388        t,t)
 389                die "Please make up your mind. --skip or --abort?"
 390                ;;
 391        t,)
 392                git rerere clear
 393                git read-tree --reset -u HEAD HEAD
 394                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 395                git reset HEAD
 396                git update-ref ORIG_HEAD $orig_head
 397                ;;
 398        ,t)
 399                if test -f "$dotest/rebasing"
 400                then
 401                        exec git rebase --abort
 402                fi
 403                git rerere clear
 404                test -f "$dotest/dirtyindex" || {
 405                        git read-tree --reset -u HEAD ORIG_HEAD
 406                        git reset ORIG_HEAD
 407                }
 408                rm -fr "$dotest"
 409                exit ;;
 410        esac
 411        rm -f "$dotest/dirtyindex"
 412else
 413        # Make sure we are not given --skip, --resolved, nor --abort
 414        test "$skip$resolved$abort" = "" ||
 415                die "Resolve operation not in progress, we are not resuming."
 416
 417        # Start afresh.
 418        mkdir -p "$dotest" || exit
 419
 420        if test -n "$prefix" && test $# != 0
 421        then
 422                first=t
 423                for arg
 424                do
 425                        test -n "$first" && {
 426                                set x
 427                                first=
 428                        }
 429                        case "$arg" in
 430                        /*)
 431                                set "$@" "$arg" ;;
 432                        *)
 433                                set "$@" "$prefix$arg" ;;
 434                        esac
 435                done
 436                shift
 437        fi
 438
 439        check_patch_format "$@"
 440
 441        split_patches "$@"
 442
 443        # -i can and must be given when resuming; everything
 444        # else is kept
 445        echo " $git_apply_opt" >"$dotest/apply-opt"
 446        echo "$threeway" >"$dotest/threeway"
 447        echo "$sign" >"$dotest/sign"
 448        echo "$utf8" >"$dotest/utf8"
 449        echo "$keep" >"$dotest/keep"
 450        echo "$scissors" >"$dotest/scissors"
 451        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 452        echo "$GIT_QUIET" >"$dotest/quiet"
 453        echo 1 >"$dotest/next"
 454        if test -n "$rebasing"
 455        then
 456                : >"$dotest/rebasing"
 457        else
 458                : >"$dotest/applying"
 459                if test -n "$HAS_HEAD"
 460                then
 461                        git update-ref ORIG_HEAD HEAD
 462                else
 463                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 464                fi
 465        fi
 466fi
 467
 468case "$resolved" in
 469'')
 470        case "$HAS_HEAD" in
 471        '')
 472                files=$(git ls-files) ;;
 473        ?*)
 474                files=$(git diff-index --cached --name-only HEAD --) ;;
 475        esac || exit
 476        if test "$files"
 477        then
 478                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 479                die "Dirty index: cannot apply patches (dirty: $files)"
 480        fi
 481esac
 482
 483if test "$(cat "$dotest/utf8")" = t
 484then
 485        utf8=-u
 486else
 487        utf8=-n
 488fi
 489if test "$(cat "$dotest/keep")" = t
 490then
 491        keep=-k
 492fi
 493case "$(cat "$dotest/scissors")" in
 494t)
 495        scissors=--scissors ;;
 496f)
 497        scissors=--no-scissors ;;
 498esac
 499if test "$(cat "$dotest/no_inbody_headers")" = t
 500then
 501        no_inbody_headers=--no-inbody-headers
 502else
 503        no_inbody_headers=
 504fi
 505if test "$(cat "$dotest/quiet")" = t
 506then
 507        GIT_QUIET=t
 508fi
 509if test "$(cat "$dotest/threeway")" = t
 510then
 511        threeway=t
 512fi
 513git_apply_opt=$(cat "$dotest/apply-opt")
 514if test "$(cat "$dotest/sign")" = t
 515then
 516        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 517                        s/>.*/>/
 518                        s/^/Signed-off-by: /'
 519                `
 520else
 521        SIGNOFF=
 522fi
 523
 524last=`cat "$dotest/last"`
 525this=`cat "$dotest/next"`
 526if test "$skip" = t
 527then
 528        this=`expr "$this" + 1`
 529        resume=
 530fi
 531
 532if test "$this" -gt "$last"
 533then
 534        say Nothing to do.
 535        rm -fr "$dotest"
 536        exit
 537fi
 538
 539while test "$this" -le "$last"
 540do
 541        msgnum=`printf "%0${prec}d" $this`
 542        next=`expr "$this" + 1`
 543        test -f "$dotest/$msgnum" || {
 544                resume=
 545                go_next
 546                continue
 547        }
 548
 549        # If we are not resuming, parse and extract the patch information
 550        # into separate files:
 551        #  - info records the authorship and title
 552        #  - msg is the rest of commit log message
 553        #  - patch is the patch body.
 554        #
 555        # When we are resuming, these files are either already prepared
 556        # by the user, or the user can tell us to do so by --resolved flag.
 557        case "$resume" in
 558        '')
 559                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 560                        <"$dotest/$msgnum" >"$dotest/info" ||
 561                        stop_here $this
 562
 563                # skip pine's internal folder data
 564                sane_grep '^Author: Mail System Internal Data$' \
 565                        <"$dotest"/info >/dev/null &&
 566                        go_next && continue
 567
 568                test -s "$dotest/patch" || {
 569                        echo "Patch is empty.  Was it split wrong?"
 570                        stop_here $this
 571                }
 572                if test -f "$dotest/rebasing" &&
 573                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 574                                -e q "$dotest/$msgnum") &&
 575                        test "$(git cat-file -t "$commit")" = commit
 576                then
 577                        git cat-file commit "$commit" |
 578                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 579                else
 580                        {
 581                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 582                                echo
 583                                cat "$dotest/msg"
 584                        } |
 585                        git stripspace > "$dotest/msg-clean"
 586                fi
 587                ;;
 588        esac
 589
 590        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 591        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 592        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 593
 594        if test -z "$GIT_AUTHOR_EMAIL"
 595        then
 596                echo "Patch does not have a valid e-mail address."
 597                stop_here $this
 598        fi
 599
 600        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 601
 602        case "$resume" in
 603        '')
 604            if test '' != "$SIGNOFF"
 605            then
 606                LAST_SIGNED_OFF_BY=`
 607                    sed -ne '/^Signed-off-by: /p' \
 608                    "$dotest/msg-clean" |
 609                    sed -ne '$p'
 610                `
 611                ADD_SIGNOFF=`
 612                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 613                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 614                    echo "$SIGNOFF"
 615                }`
 616            else
 617                ADD_SIGNOFF=
 618            fi
 619            {
 620                if test -s "$dotest/msg-clean"
 621                then
 622                        cat "$dotest/msg-clean"
 623                fi
 624                if test '' != "$ADD_SIGNOFF"
 625                then
 626                        echo "$ADD_SIGNOFF"
 627                fi
 628            } >"$dotest/final-commit"
 629            ;;
 630        *)
 631                case "$resolved$interactive" in
 632                tt)
 633                        # This is used only for interactive view option.
 634                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 635                        ;;
 636                esac
 637        esac
 638
 639        resume=
 640        if test "$interactive" = t
 641        then
 642            test -t 0 ||
 643            die "cannot be interactive without stdin connected to a terminal."
 644            action=again
 645            while test "$action" = again
 646            do
 647                echo "Commit Body is:"
 648                echo "--------------------------"
 649                cat "$dotest/final-commit"
 650                echo "--------------------------"
 651                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 652                read reply
 653                case "$reply" in
 654                [yY]*) action=yes ;;
 655                [aA]*) action=yes interactive= ;;
 656                [nN]*) action=skip ;;
 657                [eE]*) git_editor "$dotest/final-commit"
 658                       action=again ;;
 659                [vV]*) action=again
 660                       : ${GIT_PAGER=$(git var GIT_PAGER)}
 661                       : ${LESS=-FRSX}
 662                       export LESS
 663                       $GIT_PAGER "$dotest/patch" ;;
 664                *)     action=again ;;
 665                esac
 666            done
 667        else
 668            action=yes
 669        fi
 670        FIRSTLINE=$(sed 1q "$dotest/final-commit")
 671
 672        if test $action = skip
 673        then
 674                go_next
 675                continue
 676        fi
 677
 678        if test -x "$GIT_DIR"/hooks/applypatch-msg
 679        then
 680                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 681                stop_here $this
 682        fi
 683
 684        say "Applying: $FIRSTLINE"
 685
 686        case "$resolved" in
 687        '')
 688                # When we are allowed to fall back to 3-way later, don't give
 689                # false errors during the initial attempt.
 690                squelch=
 691                if test "$threeway" = t
 692                then
 693                        squelch='>/dev/null 2>&1 '
 694                fi
 695                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 696                apply_status=$?
 697                ;;
 698        t)
 699                # Resolved means the user did all the hard work, and
 700                # we do not have to do any patch application.  Just
 701                # trust what the user has in the index file and the
 702                # working tree.
 703                resolved=
 704                git diff-index --quiet --cached HEAD -- && {
 705                        echo "No changes - did you forget to use 'git add'?"
 706                        stop_here_user_resolve $this
 707                }
 708                unmerged=$(git ls-files -u)
 709                if test -n "$unmerged"
 710                then
 711                        echo "You still have unmerged paths in your index"
 712                        echo "did you forget to use 'git add'?"
 713                        stop_here_user_resolve $this
 714                fi
 715                apply_status=0
 716                git rerere
 717                ;;
 718        esac
 719
 720        if test $apply_status = 1 && test "$threeway" = t
 721        then
 722                if (fall_back_3way)
 723                then
 724                    # Applying the patch to an earlier tree and merging the
 725                    # result may have produced the same tree as ours.
 726                    git diff-index --quiet --cached HEAD -- && {
 727                        say No changes -- Patch already applied.
 728                        go_next
 729                        continue
 730                    }
 731                    # clear apply_status -- we have successfully merged.
 732                    apply_status=0
 733                fi
 734        fi
 735        if test $apply_status != 0
 736        then
 737                printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
 738                stop_here_user_resolve $this
 739        fi
 740
 741        if test -x "$GIT_DIR"/hooks/pre-applypatch
 742        then
 743                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 744        fi
 745
 746        tree=$(git write-tree) &&
 747        commit=$(
 748                if test -n "$ignore_date"
 749                then
 750                        GIT_AUTHOR_DATE=
 751                fi
 752                parent=$(git rev-parse --verify -q HEAD) ||
 753                say >&2 "applying to an empty history"
 754
 755                if test -n "$committer_date_is_author_date"
 756                then
 757                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 758                        export GIT_COMMITTER_DATE
 759                fi &&
 760                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 761        ) &&
 762        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 763        stop_here $this
 764
 765        if test -x "$GIT_DIR"/hooks/post-applypatch
 766        then
 767                "$GIT_DIR"/hooks/post-applypatch
 768        fi
 769
 770        go_next
 771done
 772
 773git gc --auto
 774
 775rm -fr "$dotest"